
AncColPlotTrioPhasedNamed = function(fileName, prbs, popCols = NULL, nPop = NULL,
nSnp = NULL, snpInds = NULL,
add = FALSE, baseLine = 0, ylim = c(0, 1),
drawFunc = polygon, ...) {
	if (!is.null(nPop) && dim(prbs)[1] != nPop) {
		stop("dimensions do not matched passed in nPop")
	} else if (!is.null(nSnp) && dim(prbs)[2] != nSnp) {
		stop("dimensions do not matched passed in nSnp")
	}
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]
	
	
	if (is.null(popCols)) {
		popCols = c("blue", "red", "orange", "purple", rainbow(nPop))
	}
	
	v = rep(baseLine, nSnp)
	
	if (is.null(snpInds)) {
		snpInds = 1:nSnp
	}
	
	x = c(snpInds, rev(snpInds))
	
	if (!add) {
		pdf(fileName)
		plot(range(snpInds), ylim, col = "white", xlab = "snp-index",
			 ylab = "", ...)
	}
	for (popIdx in 1:nPop) {
		v2 = v + prbs[popIdx, ]
		y = c(v, rev(v2))
		drawFunc(x = x, y = y, col = popCols[popIdx])
		v = v2
	}
	dev.off()								
	
	
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]	
	
	
	lengthName = nchar(fileName)
	person = fileName
	popSeq = seq(from = 1, to = nPop, by = 1 )
	pop_names= cbind()
	person_names= cbind()
	for(x in popSeq){
		pop_names= rbind(pop_names, paste("Population_", x))
		person_names= rbind(person_names, paste("Haplotype", person))
		
	}
	new_m = cbind(person_names, pop_names, prbs, deparse.level = 0)
	short_string = sub(".pdf*", "", fileName)
	write.table(new_m, file = paste(short_string,".txt", sep =""), sep = "\t", quote = FALSE, row.names = FALSE,col.names = FALSE)
	
	
}

AncColPlotStatsPhasedNamed_new = function(fileName, prbs, popCols = NULL, nPop = NULL,
nSnp = NULL, snpInds = NULL,
add = FALSE, baseLine = 0, ylim = c(0, 2),
drawFunc = polygon, ...) {
	if (!is.null(nPop) && dim(prbs)[1] != nPop) {
		stop("dimensions do not matched passed in nPop")
	} else if (!is.null(nSnp) && dim(prbs)[2] != nSnp) {
		stop("dimensions do not matched passed in nSnp")
	}
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]
	
	
	if (is.null(popCols)) {
		popCols = c("blue", "red", "orange", "purple", rainbow(nPop))
	}
	
	v = rep(baseLine, nSnp)
	
	if (is.null(snpInds)) {
		snpInds = 1:nSnp
	}
	
	x = c(snpInds, rev(snpInds))
	
	if (!add) {
		pdf(fileName)
		plot(range(snpInds), ylim, col = "white", xlab = "snp-index",
			 ylab = "", ...)
	}
	for (popIdx in 1:nPop) {
		v2 = v + prbs[popIdx, ]
		y = c(v, rev(v2))
		drawFunc(x = x, y = y, col = popCols[popIdx])
		v = v2
	}
	dev.off()								
	
	
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]	
	
	
	lengthName = nchar(fileName)
	person = fileName
	popSeq = seq(from = 1, to = nPop, by = 1 )
	pop_names= cbind()
	person_names= cbind()
	for(x in popSeq){
		pop_names= rbind(pop_names, paste("Population_", x))
		person_names= rbind(person_names, paste("Haplotype", person))
		
	}
	new_m = cbind(person_names, pop_names, prbs, deparse.level = 0)
	short_string = sub(".pdf*", "", fileName)
	write.table(new_m, file = paste(short_string,".txt", sep =""), sep = "\t", quote = FALSE, row.names = FALSE,col.names = FALSE)
	
	
}


AncColPlotTrioPhasedNamedNoGraphics = function(fileName, prbs, popCols = NULL, nPop = NULL,
nSnp = NULL, snpInds = NULL,
add = FALSE, baseLine = 0, ylim = c(0, 1),
drawFunc = polygon, ...) {
	if (!is.null(nPop) && dim(prbs)[1] != nPop) {
		stop("dimensions do not matched passed in nPop")
	} else if (!is.null(nSnp) && dim(prbs)[2] != nSnp) {
		stop("dimensions do not matched passed in nSnp")
	}
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]
	
	
	if (is.null(popCols)) {
		popCols = c("blue", "red", "orange", "purple", rainbow(nPop))
	}
	
	v = rep(baseLine, nSnp)
	
	if (is.null(snpInds)) {
		snpInds = 1:nSnp
	}
	
	x = c(snpInds, rev(snpInds))
	
								
	
	
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]	
	
	
	lengthName = nchar(fileName)
	person = fileName
	popSeq = seq(from = 1, to = nPop, by = 1 )
	pop_names= cbind()
	person_names= cbind()
	for(x in popSeq){
		pop_names= rbind(pop_names, paste("Population_", x))
		person_names= rbind(person_names, paste("Haplotype", person))
		
	}
	new_m = cbind(person_names, pop_names, prbs, deparse.level = 0)
	short_string = sub(".pdf*", "", fileName)
	write.table(new_m, file = paste(short_string,".txt", sep =""), sep = "\t", quote = FALSE, row.names = FALSE,col.names = FALSE)
	
	
}

AncColPlotStatsPhasedNamedNoGraphics_new = function(fileName, prbs, popCols = NULL, nPop = NULL,
nSnp = NULL, snpInds = NULL,
add = FALSE, baseLine = 0, ylim = c(0, 2),
drawFunc = polygon, ...) {
	if (!is.null(nPop) && dim(prbs)[1] != nPop) {
		stop("dimensions do not matched passed in nPop")
	} else if (!is.null(nSnp) && dim(prbs)[2] != nSnp) {
		stop("dimensions do not matched passed in nSnp")
	}
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]
	
	
	if (is.null(popCols)) {
		popCols = c("blue", "red", "orange", "purple", rainbow(nPop))
	}
	
	v = rep(baseLine, nSnp)
	
	if (is.null(snpInds)) {
		snpInds = 1:nSnp
	}
	
	x = c(snpInds, rev(snpInds))
	
	
	
	
	nSnp = dim(prbs)[2]
	nPop = dim(prbs)[1]	
	
	
	lengthName = nchar(fileName)
	person = fileName
	popSeq = seq(from = 1, to = nPop, by = 1 )
	pop_names= cbind()
	person_names= cbind()
	for(x in popSeq){
		pop_names= rbind(pop_names, paste("Population_", x))
		person_names= rbind(person_names, paste("Haplotype", person))
		
	}
	new_m = cbind(person_names, pop_names, prbs, deparse.level = 0)
	short_string = sub(".pdf*", "", fileName)
	write.table(new_m, file = paste(short_string,".txt", sep =""), sep = "\t", quote = FALSE, row.names = FALSE,col.names = FALSE)
	
	
}


AncColPlotStatsPhasedNamed = function(file_name, prbs, popCols = NULL, nPop = NULL,
nSnp = NULL, snpInds = NULL,
add = FALSE, baseLine = 0, ylim = c(0, 2),
...) {
	if (!is.null(nPop) && dim(prbs)[1] != nPop) {
		stop("dimensions do not matched passed in nPop")
	} else if (!is.null(nSnp) && dim(prbs)[3] != nSnp) {
		stop("dimensions do not matched passed in nSnp")
	}
	nSnp = dim(prbs)[3]
	nPop = dim(prbs)[1]
	
	if (is.null(popCols)) {
		popCols = c("blue", "red", "orange", "purple", rainbow(nPop))
	}
	
	m = matrix(nrow = nPop, ncol = nSnp, data = 0)
	for (g1 in 1:nPop) {
		for (g2 in 1:nPop) {
			v = prbs[g1, g2, ]
			m[g1,] = m[g1,] + v
			m[g2,] = m[g2,] + v
		}}
	
	lengthName = nchar(file_name)
	person = file_name
	popSeq = seq(from = 1, to = nPop, by = 1 )
	pop_names= cbind()
	person_names= cbind()
	for(x in popSeq){
		pop_names= rbind(pop_names, paste("Population_", x))
		person_names= rbind(person_names, paste("Haplotype", person))
		
	}
	new_m = cbind(person_names, pop_names, m, deparse.level = 0)
	short_string = sub("\\..*", "", file_name)
	

	write.table(new_m, file = paste(short_string,".txt", sep=""), sep = "\t", quote = FALSE, row.names = FALSE,col.names = FALSE)
	
	
	v = rep(baseLine, nSnp)
	if (is.null(snpInds)) {
		snpInds = 1:nSnp
	}
	
	x = c(snpInds, rev(snpInds))
	
	if (!add) {
		pdf(file_name)
		plot(c(1, nSnp), c(0, 2), col = "white", xlab = "snp-index",
			 ylab = "", ylim = ylim, ...)
		
	}
	for (popIdx in 1:nPop) {
		v2 = v + m[popIdx, ]
		y = c(v, rev(v2))
		polygon(x = x, y = y, col = popCols[popIdx])
		v = v2
		
	}
	dev.off()
}

AncColPlotStatsPhasedNamedNoGraphics = function(file_name, prbs, popCols = NULL, nPop = NULL,
nSnp = NULL, snpInds = NULL,
add = FALSE, baseLine = 0, ylim = c(0, 2),
...) {
	if (!is.null(nPop) && dim(prbs)[1] != nPop) {
		stop("dimensions do not matched passed in nPop")
	} else if (!is.null(nSnp) && dim(prbs)[3] != nSnp) {
		stop("dimensions do not matched passed in nSnp")
	}
	nSnp = dim(prbs)[3]
	nPop = dim(prbs)[1]
	
	if (is.null(popCols)) {
		popCols = c("blue", "red", "orange", "purple", rainbow(nPop))
	}
	
	m = matrix(nrow = nPop, ncol = nSnp, data = 0)
	for (g1 in 1:nPop) {
		for (g2 in 1:nPop) {
			v = prbs[g1, g2, ]
			m[g1,] = m[g1,] + v
			m[g2,] = m[g2,] + v
		}}
	
	lengthName = nchar(file_name)
	person = file_name
	popSeq = seq(from = 1, to = nPop, by = 1 )
	pop_names= cbind()
	person_names= cbind()
	for(x in popSeq){
		pop_names= rbind(pop_names, paste("Population_", x))
		person_names= rbind(person_names, paste("Haplotype", person))
		
	}
	new_m = cbind(person_names, pop_names, m, deparse.level = 0)
	short_string = sub("\\..*", "", file_name)
	
	
	write.table(new_m, file = paste(short_string,".txt", sep=""), sep = "\t", quote = FALSE, row.names = FALSE,col.names = FALSE)
	
	
	v = rep(baseLine, nSnp)
	if (is.null(snpInds)) {
		snpInds = 1:nSnp
	}
	
	x = c(snpInds, rev(snpInds))
	
	
}