
SwitchError = function(truePh, testPh, phKnown = NULL) {
  nr = nrow(truePh)
  nc = ncol(truePh)

  if (is.null(phKnown)) {
    # phKnown = MatrixFill(BinaryMat(nr, nc), 1)
    phKnown = matrix(nrow = nr, ncol = nc, data = as.integer(1))
  }

  nErrs = as.integer(0)
  nTests = as.integer(0)

  .Call("SwitchErrorCalc", truePh, phKnown,
        testPh, nErrs, nTests,
        PACKAGE = kPhaseEmPkgName)
  return(c(nErrs / nTests, nTests, nErrs))
}

SwitchErrByDist = function(truePh, testPh,
                           distBins = NULL,
                           posns = NULL, maxDist = 300,
                           phKnown = NULL) {
  nr = nrow(truePh)
  nc = ncol(truePh)

  if (is.null(phKnown)) {
    phKnown = MatrixFill(BinaryMat(nr, nc), 1)
  }

  if (is.null(distBins) && is.null(posns)) {
    distBins = as.double(1:maxDist)
  } else if (is.null(distBins)) {
    distBins = as.double(seq(from = 0, to = maxDist, length = 30))
    distBins = distBins[-1]
  }

  if (is.null(posns)) {
    posns = 0:(nc-1)
  }
  posns = as.double(posns)

  nErrs = rep(as.integer(0), length(distBins))
  nTests = rep(as.integer(0), length(distBins))

  .Call("SwitchErrByDist", truePh, phKnown,
        testPh, posns, distBins, nErrs, nTests,
        PACKAGE = kPhaseEmPkgName)
  return(list(distBins = distBins,
              errs = rbind(nErrs / nTests, nTests, nErrs)))
}