#include <R.h>
#include <Rinternals.h>
#include <R_ext/Rdynload.h>

extern "C" {
// declaring functions for exporting

// matrix stuff.  look in 'binary_mat_util.cpp'

SEXP MarginSums(SEXP mat_sxp, SEXP margin_idx_sxp, SEXP r_sxp);

SEXP ConvertMatrix(SEXP mat1_sxp, SEXP row_inds_sxp, SEXP col_inds_sxp,
                   SEXP mat2_sxp);
SEXP ConvertMatrixDbl(SEXP mat1_sxp, SEXP row_inds_sxp, SEXP col_inds_sxp,
                      SEXP mat2_sxp);
SEXP TransposeMatrix(SEXP mat1_sxp, SEXP mat2_sxp);
SEXP RbindMatrix(SEXP mat1_sxp, SEXP mat2_sxp, SEXP mat3_sxp);
SEXP CbindMatrix(SEXP mat1_sxp, SEXP mat2_sxp, SEXP mat3_sxp);

SEXP FillMatrix(SEXP val_sxp, SEXP mat_sxp);

SEXP SetMatrixSlice(SEXP mat1_sxp, SEXP row_inds_sxp, SEXP col_inds_sxp,
			              SEXP mat2_sxp);

// pca stuff.  look in 'binary_mat_util.cpp'
SEXP MaskedPcaLRUpdate(SEXP mat_sxp, SEXP msk_sxp, SEXP fact_idx_sxp,
                       SEXP fm_sxp, SEXP tied_cols_sxp);
SEXP MaskedPcaSubSpaceGrad(SEXP mat_sxp, SEXP msk_sxp, SEXP fm_sxp,
		                       SEXP fm_grad_sxp);
SEXP MaskedPcaSubSpaceSqrs(SEXP mat_sxp, SEXP msk_sxp, SEXP fm_sxp,
		                       SEXP fm_grad_sxp);
SEXP MaskedPcaSqrErr(SEXP mat_sxp, SEXP msk_sxp, SEXP fm_sxp);

// phasing stuff
SEXP PhaseEmExpCounts_RI(SEXP params_sxp, SEXP cases_sxp, SEXP case_inds_sxp,
                         SEXP jump_counts_sxp, SEXP mut_counts_sxp,
                         SEXP pliks_sxp);

SEXP PhaseEmGenotypeCodes_RI(SEXP allele_mat_sxp, SEXP gtype_mat_sxp);

SEXP PhaseEmCrossoverScores_RI(SEXP params_sxp, SEXP cases_sxp,
                               SEXP case_idx1_sxp, SEXP case_idx2_sxp);

SEXP PhaseEmCrossoverOpt_RI(SEXP params_sxp, SEXP cases_sxp,
                            SEXP case_inds_sxp, SEXP move_thresh_sxp,
                            SEXP back_tracking_sxp);

SEXP PhaseEmHapOptScores_RI(SEXP params_sxp, SEXP cases_sxp,
                            SEXP case_idx1_sxp, SEXP case_idx2_sxp,
                            SEXP allow_crossover_sxp,
                            SEXP gtype_codes_sxp);

SEXP PhaseEmHapOpt_RI(SEXP params_sxp, SEXP cases_sxp,
                      SEXP case_inds_sxp, SEXP move_thresh_sxp,
                      SEXP allow_crossover_sxp,
                      SEXP allow_single_site_sxp,
                      SEXP gtype_codes_sxp,
                      SEXP back_tracking_sxp);

// matrix stuff
SEXP MatrixCompMult(SEXP m1_sxp, SEXP m2_sxp, SEXP m3_sxp);
SEXP MatrixNegate(SEXP m1_sxp, SEXP m2_sxp);

// admixture stuff
SEXP GrowBinTrees_RI(SEXP bin_mat, SEXP p_pop_labels,
								    SEXP p_max_index_diffs, SEXP p_mdl_params_sxp,
								    SEXP p_split_penalty, SEXP p_pop_idx, SEXP p_verbose,
								    SEXP split_lists, SEXP split_counts);

SEXP IncLeafCounts_RI(SEXP bin_mat, SEXP wts_sxp, SEXP zero_counts_sxp,
		                   SEXP p_mdl_params_sxp, SEXP tree_sxp);

SEXP PerMarkerLLiks_RI(SEXP bin_mat, SEXP wts_sxp, SEXP tree_sxp,
		                   SEXP lliks_sxp);

SEXP FirstUnclippedTreeIndex_RI(SEXP trees_sxp, SEXP max_drop_sxp);

SEXP PackIntsToUnsignedChars_RI(SEXP ints_sxp);
SEXP AradmxPackDropLookups_RI(SEXP dropLookupsSxp);

SEXP AradmxCtTreesToPrbTrees_RI(SEXP bin_trees_sxp, SEXP packed_trees_sxp,
		                            SEXP tree_posns_sxp,
		                            SEXP pcount_sxp);

SEXP AradmxPhasedExactFwdBkwd_RI(SEXP hap_sxp, SEXP drop_lookups_sxp, SEXP max_drop_sxp,
	                              SEXP junc_tree_sxp, SEXP win_sz_sxp,              // The state matrix
	                              SEXP anc_transprb_sxp, SEXP anc_priors_sxp, // Recombination and ancestral prior parameters
	                              SEXP bin_trees_sxp,    // Parent sets and their observed counts/multinomial parameters
	                              SEXP pop_lab_sxp,
	                              SEXP checkpointed_sxp,
	                              SEXP marg_lik_sxp, SEXP anc_prbs_sxp);

SEXP AradmxUnphApproxFwdBkwd_RI(SEXP hap1_sxp, SEXP hap2_sxp,
		                          SEXP drop_lookups_sxp, SEXP max_drop_sxp,
                              SEXP junc_tree_sxp, SEXP win_sz_sxp,              // The state matrix
                              SEXP anc_transprb_sxp, SEXP anc_priors_sxp, // Recombination and ancestral prior parameters
                              SEXP bin_trees_sxp,    // Parent sets and their observed counts/multinomial parameters
                              SEXP pop_lab_sxp,
                              SEXP checkpointed_sxp,
                              SEXP marg_lik_sxp, SEXP anc_prbs_sxp);

void R_init_PHASEEM(DllInfo *info) {
  R_CallMethodDef  callMethods[] = {
            {"ConvertMatrix", (void* (*)()) &ConvertMatrix, 4},
            {"ConvertMatrixDbl", (void* (*)()) &ConvertMatrixDbl, 4},
            {"TransposeMatrix", (void* (*)()) &TransposeMatrix, 2},
            {"MarginSums", (void* (*)()) &MarginSums, 3},
            {"RbindMatrix", (void* (*)()) &RbindMatrix, 3},
            {"CbindMatrix", (void* (*)()) &CbindMatrix, 3},
            {"MatrixCompMult", (void* (*)()) &MatrixCompMult, 3},
            {"MatrixNegate", (void* (*)()) &MatrixNegate, 2},
            {"SetMatrixSlice", (void* (*)()) &SetMatrixSlice, 4},
            {"MaskedPcaLRUpdate", (void* (*)()) &MaskedPcaLRUpdate, 5},
            {"MaskedPcaSubSpaceGrad", (void* (*)()) &MaskedPcaSubSpaceGrad, 4},
            {"MaskedPcaSubSpaceSqrs", (void* (*)()) &MaskedPcaSubSpaceSqrs, 4},
            {"MaskedPcaSqrErr", (void* (*)()) &MaskedPcaSqrErr, 3},
            {"PhaseEmExpCounts_RI", (void* (*)()) &PhaseEmExpCounts_RI, 6},
            {"PhaseEmGenotypeCodes_RI", (void* (*)()) &PhaseEmGenotypeCodes_RI, 2},
            {"PhaseEmCrossoverScores_RI", (void* (*)()) &PhaseEmCrossoverScores_RI, 4},
            {"PhaseEmCrossoverOpt_RI", (void* (*)()) &PhaseEmCrossoverOpt_RI, 5},
            {"PhaseEmHapOpt_RI", (void* (*)()) &PhaseEmHapOpt_RI, 8},
            {"GrowBinTrees_RI", (void* (*)()) &GrowBinTrees_RI, 9},
            {"IncLeafCounts_RI", (void* (*)()) &IncLeafCounts_RI, 5},
            {"PerMarkerLLiks_RI", (void* (*)()) &PerMarkerLLiks_RI, 4},
            {"FirstUnclippedTreeIndex_RI", (void* (*)()) &FirstUnclippedTreeIndex_RI, 2},
            {"PackIntsToUnsignedChars_RI", (void* (*)()) &PackIntsToUnsignedChars_RI, 1},
            {"AradmxPackDropLookups_RI", (void* (*)()) &AradmxPackDropLookups_RI, 1},
            {"AradmxCtTreesToPrbTrees_RI", (void* (*)()) &AradmxCtTreesToPrbTrees_RI, 4},
            {"AradmxPhasedExactFwdBkwd_RI", (void* (*)()) &AradmxPhasedExactFwdBkwd_RI, 12},
            {"AradmxUnphApproxFwdBkwd_RI", (void* (*)()) &AradmxUnphApproxFwdBkwd_RI, 13},
            {NULL, NULL, 0}
  };

  R_registerRoutines(info, NULL, callMethods, NULL, NULL);
}

void R_unload_PHASEEM(DllInfo *info) { }

}  // extern "C" {
